#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpq-fe.h"
#include "libpq/libpq-fs.h"

int main(int argc, char **argv)
{
  char       *database;
  char       *relation;
  char       *in_filename;
  Oid        lobjOid;
  PGconn     *connexion;
  PGresult   *retour;
  char       ordre[100];
  char       *nomFichier;
  char       *extension;      

  if (argc != 4)
    {
      fprintf(stderr, "Usage: %s nomBD cartes fichier\n", argv[0]);
      exit(1);
    }

  database = argv[1];
  relation = argv[2];
  in_filename = argv[3];

  /* Etablissement de la connexion */
  connexion = PQsetdbLogin("localhost", "5432", NULL, NULL, database, NULL, NULL);
  if (PQstatus(connexion) == CONNECTION_BAD)
    {
      fprintf(stderr, "Connection to database '%s' failed.\n", database);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    }

  strcpy (ordre, "begin");
  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
   }

  printf("import du fichier :%s:\n", in_filename);
  lobjOid = lo_import(connexion, in_filename);
  printf("import du fichier termine\n");


  /* Decoupage nom du fichier et extension */
  nomFichier = strtok(in_filename, ".");
  extension  = strtok(NULL, "\0");

  printf ("Fichier :%s: - Extension :%s:\n", nomFichier, extension);

  /* Insertion du tuple dans carte */
  sprintf (ordre, "Insert into %s (nom, format, image) values ('%s', '%s', %d);",
	   relation, nomFichier, extension, lobjOid);
  printf ("Ordre envoye :%s:\n", ordre);

  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
  }
  
  strcpy (ordre, "commit;");
  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
  }

  PQfinish(connexion);
  exit(0);
}
