#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpq-fe.h"
#include "libpq/libpq-fs.h"

#define LGRBUFFERLONG  1024
#define LGRBUFFERCOURT  100

int main(int argc, char **argv)
{
  char       *database;
  char       *relation;
  char       *cleTexte;
  int        cle;
  char       *oidTexte;
  int        oid;
  PGconn     *connexion;
  PGresult   *retour;
  int        codeObjet;
  int        codeRetour;
  char       ordre[LGRBUFFERCOURT];
  char       buffer[LGRBUFFERLONG];
  char       *extension;      

  if (argc != 5)
    {
      fprintf(stderr, "Usage: %s base relation cle oid\n", argv[0]);
      exit(1);
    }

  database         = argv[1];
  relation         = argv[2];
  cleTexte         = argv[3];
  oidTexte         = argv[4];
  cle              = atoi (cleTexte);
  oid              = atoi (oidTexte);

  /* Etablissement de la connexion */
  connexion = PQsetdbLogin("localhost", "5432", NULL, NULL, database, NULL, NULL);
  if (PQstatus(connexion) == CONNECTION_BAD)
    {
      fprintf(stderr, "Connection to database '%s' failed.\n", database);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    }

  strcpy (ordre, "begin");
  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
   }


  /* On accede au large objet */
  codeObjet = lo_open(connexion, oid, INV_READ);
  if (codeObjet == -1) 
    {
      fprintf(stderr, "Ouverture refusee\n");
      PQfinish(connexion);
      exit(1);
    }

  /* On recupere les 100er caractere du 1er bloc */
  codeRetour = lo_read(connexion, codeObjet, buffer, 100); 
  if (codeRetour < 0) 
    {
      fprintf(stderr, "Lecture refusee\n");
      PQfinish(connexion);
      exit(1);
    }

  /* On extrait l'extension */
  buffer[LGRBUFFERCOURT] = '\0'; /* reduction du buffer */
  printf ("Buffer :%s:\n",buffer);

  extension = malloc(LGRBUFFERCOURT);
  extension = strtok(buffer,"\n");
  /* on prend la chaine entre le % et le \n car du pdf */
  strncpy (extension, extension+1, strlen(extension));

  /* Insertion du tuple dans carte */
  sprintf (ordre, "Update %s set format = '%s' where cle = %d;",
	   relation, extension, cle);
  printf ("Ordre envoye :%s:\n", ordre);

  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
  }
  
  strcpy (ordre, "commit;");
  retour = PQexec(connexion, ordre);
  if (retour == NULL) 
    {
      fprintf(stderr, "Ordre refuse :%s:\n", ordre);
      fprintf(stderr, "%s", PQerrorMessage(connexion));
      PQfinish(connexion);
      exit(1);
    } else {
      PQclear(retour);
  }

  PQfinish(connexion);
  exit(0);
}
